Index: /XIOS/dev/dev_olga/src/attribute.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/attribute.hpp	(revision 1024)
+++ /XIOS/dev/dev_olga/src/attribute.hpp	(revision 1025)
@@ -55,4 +55,7 @@
             //! Returns true if and only if the attribute should be publicly exposed in the API
             virtual bool isPublic() const { return true; }
+            
+            //! Return true if the attribute should be sent to other clients or servers
+            virtual bool doSend() const { return true; }
 
             virtual void generateCInterface(ostream& oss, const string& className) = 0 ;
Index: /XIOS/dev/dev_olga/src/client_server_mapping.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/client_server_mapping.cpp	(revision 1024)
+++ /XIOS/dev/dev_olga/src/client_server_mapping.cpp	(revision 1025)
@@ -97,3 +97,8 @@
 }
 
+CClientServerMapping::GlobalIndexMap& CClientServerMapping::getGlobalIndexOnServer()
+{
+  return indexGlobalOnServer_;
+}
+
 } //namespace xios
Index: /XIOS/dev/dev_olga/src/client_server_mapping.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/client_server_mapping.hpp	(revision 1024)
+++ /XIOS/dev/dev_olga/src/client_server_mapping.hpp	(revision 1025)
@@ -42,4 +42,6 @@
     const GlobalIndexMap& getGlobalIndexOnServer() const;
 
+    GlobalIndexMap& getGlobalIndexOnServer();
+
   protected:
     //! Global index of data on SERVER, which are calculated by client(s)
Index: /XIOS/dev/dev_olga/src/config/axis_attribute_private.conf
===================================================================
--- /XIOS/dev/dev_olga/src/config/axis_attribute_private.conf	(revision 1024)
+++ /XIOS/dev/dev_olga/src/config/axis_attribute_private.conf	(revision 1025)
@@ -1,2 +1,5 @@
 DECLARE_ATTRIBUTE_PRIVATE(int, global_zoom_begin)
 DECLARE_ATTRIBUTE_PRIVATE(int, global_zoom_n)
+
+/* LOCAL DATA*/
+DECLARE_ARRAY_PRIVATE(int    ,   1 , zoom_index)
Index: /XIOS/dev/dev_olga/src/config/domain_attribute.conf
===================================================================
--- /XIOS/dev/dev_olga/src/config/domain_attribute.conf	(revision 1024)
+++ /XIOS/dev/dev_olga/src/config/domain_attribute.conf	(revision 1025)
@@ -9,17 +9,17 @@
 
 /* LOCAL */
-DECLARE_ATTRIBUTE(int             , ibegin)
-DECLARE_ATTRIBUTE(int             , ni)
+DECLARE_ATTRIBUTE(int             , ibegin, false)
+DECLARE_ATTRIBUTE(int             , ni, false)
 
 /* LOCAL */
-DECLARE_ATTRIBUTE(int             , jbegin)
-DECLARE_ATTRIBUTE(int             , nj)
+DECLARE_ATTRIBUTE(int             , jbegin, false)
+DECLARE_ATTRIBUTE(int             , nj, false)
 
 
-DECLARE_ARRAY(int,1             , i_index)
-DECLARE_ARRAY(int,1             , j_index)
+DECLARE_ARRAY(int,1             , i_index, false)
+DECLARE_ARRAY(int,1             , j_index, false)
 
 /* LOCAL */
-DECLARE_ARRAY(bool, 1 , mask_1d)
+DECLARE_ARRAY(bool, 1 , mask_1d, false)
 DECLARE_ARRAY(bool, 2 , mask_2d)
 
@@ -28,24 +28,24 @@
 
 /* LOCAL */
-DECLARE_ATTRIBUTE(int             , data_ni)
-DECLARE_ATTRIBUTE(int             , data_nj)
-DECLARE_ATTRIBUTE(int             , data_ibegin)
-DECLARE_ATTRIBUTE(int             , data_jbegin)
+DECLARE_ATTRIBUTE(int             , data_ni, false)
+DECLARE_ATTRIBUTE(int             , data_nj, false)
+DECLARE_ATTRIBUTE(int             , data_ibegin, false)
+DECLARE_ATTRIBUTE(int             , data_jbegin, false)
 
 /* LOCAL */
-DECLARE_ARRAY(int, 1 , data_i_index)
-DECLARE_ARRAY(int, 1,  data_j_index)
+DECLARE_ARRAY(int, 1 , data_i_index, false)
+DECLARE_ARRAY(int, 1,  data_j_index, false)
 
 /* LOCAL */
-DECLARE_ARRAY(double, 1, lonvalue_1d)
-DECLARE_ARRAY(double, 1, latvalue_1d)
-DECLARE_ARRAY(double, 2, lonvalue_2d)
-DECLARE_ARRAY(double, 2, latvalue_2d)
+DECLARE_ARRAY(double, 1, lonvalue_1d, false)
+DECLARE_ARRAY(double, 1, latvalue_1d, false)
+DECLARE_ARRAY(double, 2, lonvalue_2d, false)
+DECLARE_ARRAY(double, 2, latvalue_2d, false)
 
 DECLARE_ATTRIBUTE(int, nvertex)
-DECLARE_ARRAY(double, 2, bounds_lon_1d)
-DECLARE_ARRAY(double, 2, bounds_lat_1d)
-DECLARE_ARRAY(double, 3, bounds_lon_2d)
-DECLARE_ARRAY(double, 3, bounds_lat_2d)
+DECLARE_ARRAY(double, 2, bounds_lon_1d, false)
+DECLARE_ARRAY(double, 2, bounds_lat_1d, false)
+DECLARE_ARRAY(double, 3, bounds_lon_2d, false)
+DECLARE_ARRAY(double, 3, bounds_lat_2d, false)
 
 DECLARE_ARRAY(double, 2, area)
Index: /XIOS/dev/dev_olga/src/config/domain_attribute_private.conf
===================================================================
--- /XIOS/dev/dev_olga/src/config/domain_attribute_private.conf	(revision 1024)
+++ /XIOS/dev/dev_olga/src/config/domain_attribute_private.conf	(revision 1025)
@@ -18,2 +18,11 @@
 DECLARE_ATTRIBUTE_PRIVATE(int,  global_zoom_jbegin)
 DECLARE_ATTRIBUTE_PRIVATE(int,  global_zoom_nj)
+
+DECLARE_ARRAY_PRIVATE(int    ,   1 , zoom_i_index, false)
+DECLARE_ARRAY_PRIVATE(int    ,   1 , zoom_j_index, false)
+//DECLARE_ARRAY_PRIVATE(double ,   1 , areavalue, false)
+//DECLARE_ARRAY_PRIVATE(int    ,   1 , lonvalue, false)
+//DECLARE_ARRAY_PRIVATE(int    ,   1 , latvalue, false)
+//DECLARE_ARRAY_PRIVATE(int    ,   2 , bounds_lonvalue, false)
+//DECLARE_ARRAY_PRIVATE(int    ,   2 , bounds_latvalue, false)
+
Index: /XIOS/dev/dev_olga/src/declare_attribute.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/declare_attribute.hpp	(revision 1024)
+++ /XIOS/dev/dev_olga/src/declare_attribute.hpp	(revision 1025)
@@ -3,9 +3,9 @@
 
 /// ///////////////////////////// Macros ///////////////////////////// ///
-#define DECLARE_ATTRIBUTE(type, name)                             \
+#define DECLARE_ATTRIBUTE(type, name, ...)                        \
    class name##_attr : public CAttributeTemplate<type>            \
    {                                                              \
       public :                                                    \
-         name##_attr(void)                                          \
+         name##_attr(void)                                        \
             : CAttributeTemplate<type>                            \
             (#name, *CAttributeMap::Current)                      \
@@ -13,13 +13,15 @@
          type operator=(const type & value)                       \
          { return (CAttributeTemplate<type>::operator=(value)); } \
-         virtual ~name##_attr(void)                                 \
+         virtual bool doSend() const { return helper(## __VA_ARGS__); }   \
+         bool helper(bool returnTrue=true) const { return returnTrue; }   \
+         virtual ~name##_attr(void)                               \
          { /* Ne rien faire de plus */ }                          \
    } name;
 
-#define DECLARE_ATTRIBUTE_PRIVATE(type, name)                    \
-   class name##_attr : public CAttributeTemplate<type>           \
+#define DECLARE_ATTRIBUTE_PRIVATE(type, name, ...)                \
+   class name##_attr : public CAttributeTemplate<type>            \
    {                                                              \
       public :                                                    \
-         name##_attr(void)                                          \
+         name##_attr(void)                                        \
             : CAttributeTemplate<type>                            \
             (#name, *CAttributeMap::Current)                      \
@@ -29,9 +31,11 @@
          virtual bool isPublic() const                            \
          { return false; }                                        \
+         virtual bool doSend() const { return helper(## __VA_ARGS__); }   \
+         bool helper(bool returnTrue=true) const { return returnTrue; }   \
          virtual ~name##_attr(void)                               \
          { /* Ne rien faire de plus */ }                          \
    } name;
 
-#define DECLARE_ARRAY(T_num, T_rank, name)                        \
+#define DECLARE_ARRAY(T_num, T_rank, name, ...)                   \
    class name##_attr : public CAttributeArray<T_num, T_rank>      \
    {                                                              \
@@ -39,8 +43,10 @@
          using CAttributeArray<T_num, T_rank>::operator = ;       \
          name##_attr(void) : CAttributeArray<T_num, T_rank> (#name, *CAttributeMap::Current) {} \
+         virtual bool doSend() const { return helper(## __VA_ARGS__); }   \
+         bool helper(bool returnTrue=true) const { return returnTrue; }   \
          virtual ~name##_attr(void) {}                            \
    } name;
 
-#define DECLARE_ARRAY_PRIVATE(T_num, T_rank, name)                        \
+#define DECLARE_ARRAY_PRIVATE(T_num, T_rank, name, ...)           \
    class name##_attr : public CAttributeArray<T_num, T_rank>      \
    {                                                              \
@@ -50,13 +56,17 @@
          virtual bool isPublic() const                            \
          { return false; }                                        \
+         virtual bool doSend() const { return helper(## __VA_ARGS__); }   \
+         bool helper(bool returnTrue=true) const { return returnTrue; }   \
          virtual ~name##_attr(void) {}                            \
    } name;
 
-#define DECLARE_CLASS_ENUM(name)                                   \
-   class name##_attr : public CAttributeEnum<Enum_##name>          \
+#define DECLARE_CLASS_ENUM(name, ...)                             \
+   class name##_attr : public CAttributeEnum<Enum_##name>         \
    {                                                              \
       public :                                                    \
          name##_attr(void) : CAttributeEnum<Enum_##name>(#name, *CAttributeMap::Current) { } \
-         virtual ~name##_attr(void) {}                           \
+         virtual bool doSend() const { return helper(## __VA_ARGS__); }   \
+         bool helper(bool returnTrue=true) const { return returnTrue; }   \
+         virtual ~name##_attr(void) {}                            \
    } name;
 
@@ -71,9 +81,9 @@
    DECLARE_CLASS_ENUM(name)
 
-#define DECLARE_ENUM3(name,arg1,arg2,arg3)                             \
+#define DECLARE_ENUM3(name,arg1,arg2,arg3)                        \
    class Enum_##name                                              \
    {                                                              \
      public:                                                      \
-     enum t_enum { arg1=0, arg2, arg3} ;                                \
+     enum t_enum { arg1=0, arg2, arg3} ;                          \
      const char** getStr(void) const { static const char * enumStr[] = { #arg1, #arg2, #arg3 } ; return enumStr ; }   \
      int getSize(void) const { return 3 ; }                       \
@@ -81,9 +91,9 @@
    DECLARE_CLASS_ENUM(name)
 
-#define DECLARE_ENUM4(name,arg1,arg2,arg3,arg4)                             \
+#define DECLARE_ENUM4(name,arg1,arg2,arg3,arg4)                   \
    class Enum_##name                                              \
    {                                                              \
      public:                                                      \
-     enum t_enum { arg1=0, arg2, arg3,arg4} ;                                \
+     enum t_enum { arg1=0, arg2, arg3,arg4} ;                     \
      const char** getStr(void) const { static const char * enumStr[] = { #arg1, #arg2, #arg3,#arg4 } ; return enumStr ; }   \
      int getSize(void) const { return 4 ; }                       \
@@ -91,9 +101,9 @@
    DECLARE_CLASS_ENUM(name)
 
-#define DECLARE_ENUM5(name,arg1,arg2,arg3,arg4,arg5)                             \
+#define DECLARE_ENUM5(name,arg1,arg2,arg3,arg4,arg5)              \
    class Enum_##name                                              \
    {                                                              \
      public:                                                      \
-     enum t_enum { arg1=0, arg2, arg3,arg4,arg5} ;                                \
+     enum t_enum { arg1=0, arg2, arg3,arg4,arg5} ;                \
      const char** getStr(void) const { static const char * enumStr[] = { #arg1, #arg2, #arg3,#arg4,#arg5 } ; return enumStr ; }   \
      int getSize(void) const { return 5 ; }                       \
@@ -101,9 +111,9 @@
    DECLARE_CLASS_ENUM(name)
 
-#define DECLARE_ENUM6(name,arg1,arg2,arg3,arg4,arg5,arg6)                             \
+#define DECLARE_ENUM6(name,arg1,arg2,arg3,arg4,arg5,arg6)         \
    class Enum_##name                                              \
    {                                                              \
      public:                                                      \
-     enum t_enum { arg1=0, arg2, arg3,arg4,arg5,arg6} ;                                \
+     enum t_enum { arg1=0, arg2, arg3,arg4,arg5,arg6} ;           \
      const char** getStr(void) const { static const char * enumStr[] = { #arg1, #arg2, #arg3,#arg4,#arg5,#arg6 } ; return enumStr ; }   \
      int getSize(void) const { return 6 ; }                       \
@@ -111,9 +121,9 @@
    DECLARE_CLASS_ENUM(name)
 
-#define DECLARE_ENUM7(name,arg1,arg2,arg3,arg4,arg5,arg6,arg7)                             \
+#define DECLARE_ENUM7(name,arg1,arg2,arg3,arg4,arg5,arg6,arg7)    \
    class Enum_##name                                              \
    {                                                              \
      public:                                                      \
-     enum t_enum { arg1=0, arg2, arg3,arg4,arg5,arg6,arg7} ;                                \
+     enum t_enum { arg1=0, arg2, arg3,arg4,arg5,arg6,arg7} ;      \
      const char** getStr(void) const { static const char * enumStr[] = { #arg1, #arg2, #arg3,#arg4,#arg5,#arg6,#arg7 } ; return enumStr ; }   \
      int getSize(void) const { return 7 ; }                       \
@@ -125,5 +135,5 @@
    {                                                              \
      public:                                                      \
-     enum t_enum { arg1=0, arg2, arg3,arg4,arg5,arg6,arg7,arg8} ;                                \
+     enum t_enum { arg1=0, arg2, arg3,arg4,arg5,arg6,arg7,arg8} ; \
      const char** getStr(void) const { static const char * enumStr[] = { #arg1, #arg2, #arg3,#arg4,#arg5,#arg6,#arg7,#arg8 } ; return enumStr ; }   \
      int getSize(void) const { return 8 ; }                       \
Index: /XIOS/dev/dev_olga/src/distribution_client.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/distribution_client.cpp	(revision 1024)
+++ /XIOS/dev/dev_olga/src/distribution_client.cpp	(revision 1025)
@@ -11,5 +11,5 @@
 namespace xios {
 
-CDistributionClient::CDistributionClient(int rank, const GlobalLocalDataMap& globalLocalIndex)
+CDistributionClient::CDistributionClient(int rank, CGrid* grid, const GlobalLocalDataMap& globalLocalIndex)
   : CDistribution(rank, 0)
    , axisDomainOrder_()
@@ -34,4 +34,70 @@
     ++idx;
   }
+
+  std::vector<CDomain*> domList = grid->getDomains();
+  std::vector<CAxis*> axisList = grid->getAxis();
+  std::vector<CScalar*> scalarList = grid->getScalars();
+  CArray<int,1> axisDomainOrder = grid->axis_domain_order;
+
+  int numElement = axisDomainOrder.numElements();
+  // Because domain and axis can be in any order (axis1, domain1, axis2, axis3, )
+  // their position should be specified. In axisDomainOrder, domain == true, axis == false
+  int dims = numElement;
+  idx = 0;
+  std::vector<int> indexMap(numElement);  
+  for (int i = 0; i < numElement; ++i)
+  {
+    indexMap[i] = idx;
+    if (2 == axisDomainOrder(i))
+    {
+      ++dims;
+      idx += 2;
+    }
+    else ++idx;
+  }
+
+  nGlob_.resize(dims);
+
+  // Data_n_index of domain or axis (For now, axis uses its size as data_n_index
+  dataNIndex_.resize(numElement);
+  dataDims_.resize(numElement);
+  isDataDistributed_ = false;
+  int domIndex = 0, axisIndex = 0, scalarIndex = 0;
+  for (idx = 0; idx < numElement; ++idx)
+  {
+    int eleDim = axisDomainOrder(idx);
+
+    // If this is a domain
+    if (2 == eleDim)
+    {
+      // On the j axis
+      nGlob_.at(indexMap[idx]+1)  = domList[domIndex]->nj_glo.getValue();
+      nGlob_.at(indexMap[idx]) = domList[domIndex]->ni_glo.getValue();
+      dataNIndex_.at(idx) = domList[domIndex]->data_i_index.numElements();
+      dataDims_.at(idx) = domList[domIndex]->data_dim.getValue();
+
+      isDataDistributed_ |= domList[domIndex]->isDistributed();
+      ++domIndex;
+    }
+    else if (1 == eleDim)// So it's an axis
+    {
+      nGlob_.at(indexMap[idx]) = axisList[axisIndex]->n_glo.getValue();
+      dataNIndex_.at(idx) = axisList[axisIndex]->data_index.numElements();
+      dataDims_.at(idx) = 1;
+
+      isDataDistributed_ |= axisList[axisIndex]->isDistributed();
+      ++axisIndex;
+    }
+    else // scalar
+    {
+      nGlob_.at(indexMap[idx]) = 1;
+      dataNIndex_.at(idx) = 1;
+      dataDims_.at(idx) = 1;
+
+      isDataDistributed_ |= false;
+      ++scalarIndex;
+    }
+  }
+
 }
 
@@ -192,8 +258,4 @@
   infoIndex_.resize(this->dims_);
 
-  // A trick to determine position of each domain in domainList
-  int domIndex = 0, axisIndex = 0, scalarIndex = 0;
-  idx = 0;
-
   elementLocalIndex_.resize(numElement_);
   elementGlobalIndex_.resize(numElement_);
@@ -202,9 +264,16 @@
   elementNLocal_.resize(numElement_);
   elementNGlobal_.resize(numElement_);
+
   elementNLocal_[0] = 1;
   elementNGlobal_[0] = 1;
+  isDataDistributed_ = false;
+
   size_t localSize = 1, globalSize = 1;
 
-  isDataDistributed_ = false;
+  // A trick to determine position of each domain in domainList
+  int domIndex = 0, axisIndex = 0, scalarIndex = 0;
+  idx = 0;
+
+  
   // Update all the vectors above
   for (idx = 0; idx < numElement_; ++idx)
Index: /XIOS/dev/dev_olga/src/distribution_client.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/distribution_client.hpp	(revision 1024)
+++ /XIOS/dev/dev_olga/src/distribution_client.hpp	(revision 1025)
@@ -34,5 +34,5 @@
   public:
     /** Default constructor */
-    CDistributionClient(int rank, const GlobalLocalDataMap& globalLocalIndex);
+    CDistributionClient(int rank, CGrid* grid, const GlobalLocalDataMap& globalLocalIndex);
     CDistributionClient(int rank, int dims, const CArray<size_t,1>& globalIndex = CArray<size_t,1>());
     CDistributionClient(int rank, CGrid* grid);
Index: /XIOS/dev/dev_olga/src/distribution_server.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/distribution_server.cpp	(revision 1024)
+++ /XIOS/dev/dev_olga/src/distribution_server.cpp	(revision 1025)
@@ -13,5 +13,6 @@
 
 CDistributionServer::CDistributionServer(int rank, int dims, const CArray<size_t,1>& globalIndex)
-  : CDistribution(rank, dims, globalIndex), nGlobal_(), nZoomSize_(), nZoomBegin_(), globalLocalIndexMap_()
+  : CDistribution(rank, dims, globalIndex), nGlobal_(), nZoomSize_(), nZoomBegin_(), globalLocalIndexMap_(),
+  globalIndexEachDimension_()
 {
 }
@@ -19,5 +20,6 @@
 CDistributionServer::CDistributionServer(int rank, const std::vector<int>& nZoomBegin,
                                          const std::vector<int>& nZoomSize, const std::vector<int>& nGlobal)
-  : CDistribution(rank, nGlobal.size()), nGlobal_(nGlobal), nZoomSize_(nZoomSize), nZoomBegin_(nZoomBegin), globalLocalIndexMap_()
+  : CDistribution(rank, nGlobal.size()), nGlobal_(nGlobal), nZoomSize_(nZoomSize), nZoomBegin_(nZoomBegin), globalLocalIndexMap_(),
+  globalIndexEachDimension_()
 {
   createGlobalIndex();
@@ -29,7 +31,18 @@
                                          const std::vector<int>& nGlobal)
   : CDistribution(rank, nGlobal.size()), nGlobal_(nGlobal), nZoomBeginGlobal_(nZoomBeginGlobal),
-    nZoomSize_(nZoomSize), nZoomBegin_(nZoomBegin), globalLocalIndexMap_()
+    nZoomSize_(nZoomSize), nZoomBegin_(nZoomBegin), globalLocalIndexMap_(),
+    globalIndexEachDimension_()
 {
   createGlobalIndex();
+}
+
+CDistributionServer::CDistributionServer(int rank, 
+                                         const std::vector<CArray<int,1> >& globalIndexEachDimension,
+                                         const std::vector<int>& nGlobal)
+  : CDistribution(rank, nGlobal.size()), nGlobal_(nGlobal), nZoomBeginGlobal_(),
+    nZoomSize_(), nZoomBegin_(), globalLocalIndexMap_(), 
+    globalIndexEachDimension_(globalIndexEachDimension)
+{
+  createGlobalIndexFromIndex(globalIndexEachDimension, nGlobal);
 }
 
@@ -88,4 +101,52 @@
 }
 
+void CDistributionServer::createGlobalIndexFromIndex(const std::vector<CArray<int,1> >& globalIndexOnEachDimension,
+                                                     const std::vector<int>& nbGlobal)
+{
+  size_t idx = 0, ssize = 1;
+  for (int i = 0; i < globalIndexOnEachDimension.size(); ++i) ssize *= globalIndexOnEachDimension[i].numElements();
+
+  this->globalIndex_.resize(ssize);
+  size_t nbDim = nbGlobal.size();
+  std::vector<int> idxLoop(nbDim,0);
+  std::vector<int> currentIndex(nbDim);
+  int innerLoopSize = globalIndexOnEachDimension[0].numElements();
+
+  globalLocalIndexMap_.rehash(std::ceil(ssize/globalLocalIndexMap_.max_load_factor()));
+  while (idx<ssize)
+  {
+    for (int i = 0; i < nbDim-1; ++i)
+    {
+      if (idxLoop[i] == globalIndexOnEachDimension[i].numElements())
+      {
+        idxLoop[i] = 0;
+        ++idxLoop[i+1];
+      }
+    }
+
+    for (int i = 1; i < nbDim; ++i)
+      currentIndex[i] = globalIndexOnEachDimension[i](idxLoop[i]);
+
+    size_t mulDim, globalIndex;
+    for (int i = 0; i < innerLoopSize; ++i)
+    {
+      mulDim = 1;
+      globalIndex = globalIndexOnEachDimension[0](i);
+
+      for (int k = 1; k < nbDim; ++k)
+      {
+        mulDim *= nbGlobal[k-1];
+        globalIndex += (currentIndex[k])*mulDim;
+      }
+      globalLocalIndexMap_[globalIndex] = idx;
+      this->globalIndex_(idx) = globalIndex;
+
+      ++idx;
+    }
+    idxLoop[0] += innerLoopSize;
+  }
+
+}
+
 /*!
   Compute local index for writing data on server
Index: /XIOS/dev/dev_olga/src/distribution_server.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/distribution_server.hpp	(revision 1024)
+++ /XIOS/dev/dev_olga/src/distribution_server.hpp	(revision 1025)
@@ -30,4 +30,7 @@
                         const std::vector<int>& nZoomBeginGlobal,
                         const std::vector<int>& nGlobal);
+    CDistributionServer(int rank, 
+                        const std::vector<CArray<int,1> >& globalIndexEachDimension,
+                        const std::vector<int>& nGlobal);
 
     /** Default destructor */
@@ -38,4 +41,5 @@
     const std::vector<int>& getZoomSizeServer() const;
     const GlobalLocalMap& getGlobalLocalIndex() const { return globalLocalIndexMap_; }
+    const std::vector<CArray<int,1> >& getGlobalIndexEachDimension() const; 
 
     virtual CArray<size_t,1> computeLocalIndex(const CArray<size_t,1>& globalIndex);
@@ -45,4 +49,7 @@
   protected:
     virtual void createGlobalIndex();
+
+    void createGlobalIndexFromIndex(const std::vector<CArray<int,1> >& globalIndexOnEachDimension,
+                                    const std::vector<int>& nbGlobal);
 
   protected:
@@ -54,4 +61,5 @@
     std::vector<int> nZoomSize_;
     std::vector<int> nZoomBegin_;
+    std::vector<CArray<int, 1> > globalIndexEachDimension_;
 
 };
